#!/bin/sh
OTAU_URL=http://www.dresden-elektronik.de/rpi/otau
OTAU_PATH="$HOME/otau"

while [ 1 ]; do
	FILES=`curl ${OTAU_URL}/ | grep zigbee.md5 | sed -e 's/href=/\nhref=/g' | grep 'href=' | sed -e 's/href="\([^"]*\)".*/\1/'`

	for i in $FILES; do
		fwfile=`basename $i .md5`

		if [ ! -e ${OTAU_PATH}/${i} ]; then
			wget --directory-prefix=${OTAU_PATH} ${OTAU_URL}/${i}
		fi

		if [ ! -e ${OTAU_PATH}/${fwfile} ]; then
			wget --directory-prefix=${OTAU_PATH} ${OTAU_URL}/${fwfile}
		fi

		(cd ${OTAU_PATH} && md5sum -c ${i})

		if [ $? -ne 0 ]; then
			rm -f -v ${OTAU_PATH}/${fwfile} ${OTAU_PATH}/${i}
		fi
	done

	# next run in 15 min
	sleep 900
done