var gid = null;
var config;

function displayGroups(config) {

    gid = getURLParameter('group');

    if (gid === null) {
        // go back if no id was specified
        window.location.assign('edit_groups.html');
    }

    var txt = '<div class="span12">';
    var group = undefined;

    for (var id in config.groups) {

        if (id === gid) {
            // found
            group = config.groups[id];
            break;
        }
    }

    if (group === undefined) {
        // go back if no id was specified
        window.location.assign('edit_groups.html');
    }

    txt += '<form>';
    txt += '<table class="table noborder">';
    txt += '<thead>';
    txt += '<th>Name</th><th>Model</th><th>Vendor</th><th>Version</th>';
    txt += '</thead>';
    txt += '<tbody>';

    for (var id in config.lights) {
        var l = config.lights[id];
        var checked = false;
        var disabled = "";
        var muted = "";
		var color = "#fff;";
		var hascolor = (l.state.colormode === undefined) ? false : true;

		//dont display white channel of multi-devices
		var mac = l.uniqueid.substring(0,l.uniqueid.indexOf("-"));
		var multideviceWhiteChannel = false;
		for (i in config.lights) {
			var mac2 = config.lights[i].uniqueid.substring(0,config.lights[i].uniqueid.indexOf("-"));	
			var masterHasColor = (config.lights[i].state.colormode === undefined) ? false : true;
			if (mac == mac2 && id != i && hascolor == false && masterHasColor == true) {
				multideviceWhiteChannel = true;
				
				// mark the other light as multidevice master
				config.lights[i].multideviceID = id; 
				config.lights[i].multideviceUID = l.uniqueid;
				break;
			}		
		}
		
		if (!multideviceWhiteChannel) {		
			// if already in the group mark checked
			for (var i = 0; i < group.lights.length; i++) {
				if (group.lights[i] == id) {
					checked = true;
					break;
				}
			}

			if (l.state.reachable == false) {
				disabled = " disabled ";
				muted = "muted";
				color = "#999;";
			}

			txt += '<tr>';
			txt += '<td class="' + muted + '">';
			txt += '<label class="checkbox" style="padding-left:0px;">';
			txt += '<span class="btn"' + disabled + 'style="padding-left:30px; color:' + color + '">';
			txt += '<input type="checkbox"' + disabled + ' data-lid="' + id + '"' + (checked ? ' checked="checked"' : '') + '> ' + l.name
			txt += '</span>';
			txt += '</label>';
			txt += '</td>';
			txt += '<td class="' + muted + '">' + l.modelid + '</td>';
			txt += '<td class="' + muted + '">' + l.manufacturer + '</td>';
			txt += '<td class="' + muted + '">' + l.swversion + '</td>';
			txt += '</tr>';
		}
	}
	
    txt += '</tbody>';
    txt += '</table>';
    txt += '</form>';
    txt += '</div>';

    $('.headerGroupName').html(group.name);
    $('.groups').html(txt);
}

function getFullConfiguration() {

    $.ajax({
        url: 'api/' + apikey,
        dataType: 'json',
        type: 'GET',
        cache: false,
        contentType: 'application/json; charset=utf-8',
        headers: { 'Accept': apiversion },
        success: function(json) {
            clearAlert();
            displayGroups(json);
			config = json;
        },
        error: function(jqXHR, textStatus, errorThrown) {
            switch (jqXHR.status) {
            case 403:
                window.location.assign("/login.html");
                break;

            default:
                setTimeout(getFullConfiguration, 1000);
                showAlert('alert-error', '<b>Error!</b> Lost connection, retry in one second ...');
                break;
            }
        },
        timeout: 8000
    });
}

function onSubmit() {

    // only if we have a valid group id
    if (gid === null) {
        return;
    }

    var lights = [];

    $("input[data-lid]").each(function( index ) {
        if (this.checked) {
            lights.push($(this).attr('data-lid'));
        
			// if light has a little multidevice brother
			for (i in config.lights) {
				if (i == $(this).attr('data-lid')) {
					var multiDeviceId = config.lights[i].multideviceID;
					if (multiDeviceId != undefined) {
						//double check if it is realy the correct light
						if (config.lights[i].multideviceUID == config.lights[multiDeviceId].uniqueid) {
							lights.push(multiDeviceId);
							break;
						}
					}
				}
			}
		}
    });

    $.ajax({
        url: 'api/' + apikey + '/groups/' + gid,
        dataType: 'json',
        type: 'PUT',
        cache: false,
        contentType: 'application/json; charset=utf-8',
        headers: { 'Accept': apiversion },
        data: "{ \"lights\": " + JSON.stringify(lights) + " }",
        success: function(json) {
            window.location.assign('edit_groups.html');
        },
        error: function(jqXHR, textStatus, errorThrown) {
            showAlert('alert-error', '<b>Error!</b> Failed to set group members.');
        }//,
        //timeout: 2000,
    });
}
