var config;
var POLL_DELAY = 5000;
var currentChannel;
var currentYear;
var currentMonth;
var currentDay;
var currentHour;
var currentMinute;
var currentSecond;
var currentTimezone;
var ampm = "";
	
// Set the name of the hidden property and the change event for visibility
var hidden, visibilityChange; 
if (typeof document.hidden !== "undefined") { // Opera 12.10 and Firefox 18 and later support 
  hidden = "hidden";
  visibilityChange = "visibilitychange";
} else if (typeof document.mozHidden !== "undefined") {
  hidden = "mozHidden";
  visibilityChange = "mozvisibilitychange";
} else if (typeof document.msHidden !== "undefined") {
  hidden = "msHidden";
  visibilityChange = "msvisibilitychange";
} else if (typeof document.webkitHidden !== "undefined") {
  hidden = "webkitHidden";
  visibilityChange = "webkitvisibilitychange";
}

function onSubmit(alertid) {
var setTimeAfterTimezone = false;
    var params = {
        "otauactive" : false,
		"timeformat" : "12h",
		"networkopenduration" : 60,
		"name" : "deGateway",
        "groupdelay" : 500,
        "discovery" : false
    };

    if ($('#networkUpCheckbox').prop('checked')) {
        params.rfconnected = true;
    }
	
	if ($('#internetServiceCheckbox').prop('checked')) {
        params.discovery = true;
    }
	
    if ($('#otauActiveCheckbox').prop('checked')) {
        params.otauactive = true;
    }

	params.name = $("#gwNameInput").val();
	
	params.timeformat = $('#timeFormat').val();

	params.groupdelay = parseInt($("#gwGroupDelayInput").val());

	if (($('#channelSelect').val() != currentChannel) && ($('#channelSelect').val() != 0)) {
		params.zigbeechannel = parseInt($("#channelSelect").val());
	}

	params.networkopenduration = parseFloat($("#networkOpenDuration").val())*60; //min -> sec

	// set time settings only for linux gateway and only when Advanced System Settings are shown
    if ((config.config.system == "linux-gw") && ($('#sysSetText').text() == "Advanced System Settings")) {
		
		if (checkCorrectTime() == false) {
			return;
		}

		var hourInput = (window.matchMedia("(max-width: 480px)").matches == true) ? document.getElementById('gwHoursInputPhone').value : document.getElementById('gwHoursInput').value
		
		var minutesInput = (window.matchMedia("(max-width: 480px)").matches == true) ? document.getElementById('gwMinutesInputPhone').value : document.getElementById('gwMinutesInput').value
		
		var secondsInput = (window.matchMedia("(max-width: 480px)").matches == true) ? document.getElementById('gwSecondsInputPhone').value : document.getElementById('gwSecondsInput').value
		
		var yearInput = (window.matchMedia("(max-width: 480px)").matches == true) ? document.getElementById('gwYearInputPhone').value : document.getElementById('gwYearInput').value
		
		var monthInput = (window.matchMedia("(max-width: 480px)").matches == true) ? document.getElementById('gwMonthInputPhone').value : document.getElementById('gwMonthInput').value
		
		var dayInput = (window.matchMedia("(max-width: 480px)").matches == true) ? document.getElementById('gwDayInputPhone').value : document.getElementById('gwDayInput').value
		
		if ((currentTimezone != $('.timezoneselect').val())) {
			
			$('.loading').removeClass('hidden');
			params.timezone = $('.timezoneselect').val();
			currentTimezone = $('.timezoneselect').val();
			
			//also set time when timezone is changed
			//timezone change on rpi takes sveral seconds, so it's necessary to send a second restAPI call to the gw.
			setTimeAfterTimezone = true;
			var d = new Date();
			var start = d.getTime();
		} else if((currentYear != yearInput) || (currentMonth != monthInput) || (currentDay != dayInput) || (currentHour != hourInput) || (currentMinute != minutesInput) || (currentSecond != secondsInput)) {

			var gwHour = checkTime(parseInt(hourInput));
			
			//convert 12h to 24h
			if ($('#timeFormat').val() != "24h") {
				ampm = $(".ampm").val();
				gwHour = convert12to24(gwHour);
			}

			params.utc = yearInput + "-" + checkTime(parseInt(monthInput)) + "-" + checkTime(parseInt(dayInput)) + "T" + gwHour + ":" + checkTime(parseInt(minutesInput)) + ":" + checkTime(parseInt(secondsInput));
		}
		
		var correctDate = false;
		if ((parseInt(yearInput) > 1970) && (parseInt(yearInput) < 3000) && (parseInt(monthInput) > 0) && (parseInt(monthInput) < 13) && (parseInt(dayInput) > 0) && (parseInt(dayInput) < 32)) {
			correctDate = true;
		}
	} else {
		var correctDate = true;
	}

	if (correctDate == false) {
		showAlert('alert-error', '<b>Error!</b> Date must be in the format: Year - Month - Day', alertid);
	} else {
		
		currentYear = $('.gwYearInput').val();
		currentMonth = $('.gwMonthInput').val();
		currentDay = $('.gwDayInput').val();
		currentHour = $('.gwHoursInput').val();
		currentMinute = $('.gwMinutesInput').val();
		currentSecond = $('.gwSecondsInput').val();
	
		$.ajax({
			url: 'api/' + apikey + '/config',
			dataType: 'json',
			type: 'PUT',
			contentType: 'application/json; charset=utf-8',
			headers: { 'Accept': apiversion },
			data: JSON.stringify(params),
			success: function(json) {
				showAlert('alert-success', '<b>OK!</b> Updated configuration.', alertid);
				$('.loading').addClass('hidden');
				if (setTimeAfterTimezone == true) {
					var d = new Date();
					var end = d.getTime();
					var duration = Math.ceil((end - start) / 1000);
					setTime(duration,alertid);
				}
				checkUpdatedData();
			},
			error: function(jqXHR, textStatus, errorThrown) {
				showAlert('alert-error', '<b>Error!</b> Failed to update configuration.', alertid);
			}
		});
	}

}

function setTime(dur,alertid) {
	var error = false;
	var sec = parseInt($(".gwSecondsInput").val());
	var min =  parseInt($(".gwMinutesInput").val());
	var hour = parseInt($(".gwHoursInput").val());
	
	if ((sec + parseInt(dur)) > 59) {	
	    sec = dur - (60 - sec);
		min = min + 1;
	} else {
		sec = sec + parseInt(dur);
	}
	if (min > 59) {
		min = 0;
		hour = hour + 1;
	}

	// the only problem is when the user  changes the time a few seconds before midnight
	// then ask the user kindly to try again.
	if ($('#timeFormat').val() == "24h") {
		if (hour > 23) {
			error = true;
		}
	} else {
		if (hour > 12) {
			error = true;
		}
	}

	if (error == false) {
	
		//convert 12h to 24h
		if ($('#timeFormat').val() != "24h") {
			ampm = $(".ampm").val();
			hour = convert12to24(hour);
		}
		
		var yearInput = (window.matchMedia("(max-width: 480px)").matches == true) ? document.getElementById('gwYearInputPhone').value : document.getElementById('gwYearInput').value
		
		var monthInput = (window.matchMedia("(max-width: 480px)").matches == true) ? document.getElementById('gwMonthInputPhone').value : document.getElementById('gwMonthInput').value
		
		var dayInput = (window.matchMedia("(max-width: 480px)").matches == true) ? document.getElementById('gwDayInputPhone').value : document.getElementById('gwDayInput').value
		
		var utc = yearInput + "-" + checkTime(parseInt(monthInput)) + "-" + checkTime(parseInt(dayInput)) + "T" + checkTime(hour) + ":" + checkTime(min) + ":" + checkTime(sec);
		
		$.ajax({
			url: 'api/' + apikey + '/config',
			dataType: 'json',
			type: 'PUT',
			contentType: 'application/json; charset=utf-8',
			headers: { 'Accept': apiversion },
			data: '{"utc":"' + utc + '"}',
			success: function(json) {	
				showAlert('alert-success', '<b>OK!</b> Updated configuration.',alertid);
				checkUpdatedData();
			},
			error: function(jqXHR, textStatus, errorThrown) {
				showAlert('alert-error', '<b>Error!</b> Failed to update configuration.',alertid);
			}
		});
	} else {
		showAlert('alert-error', '<b>Error!</b> Failed to update time. Please try again to set date and time.',alertid);
	}

}


function openNetwork(minutes) {

    var params = { "permitjoin" : (parseFloat(minutes)*60) };

    $.ajax({
        url: 'api/' + apikey + '/config',
        dataType: 'json',
        type: 'PUT',
        cache: false,
        contentType: 'application/json; charset=utf-8',
        headers: { 'Accept': apiversion },
        data: JSON.stringify(params),
        success: function(json) {
			var txt = '<div class="alert alert-info">';
			txt += '<button type="button" class="close" data-dismiss="alert">&times;</button>';
			txt += '<strong>Info!</strong> Network open. Check the <a href="index.html">main page</a> if new Lights where found.';
			txt += '</div>';
			$('#network-open-alert').html(txt);
        },
        error: function(jqXHR, textStatus, errorThrown) {
            showAlert('alert-error', '<b>Error!</b> Open Network failed!', '#network-alerts');
        }
    });
}

var updateTimerId;
var updateDots = "";

function displayNetworkSetting(config) {

    var otauActive = config.config["otauactive"];

    if (otauActive) {
        $('#otauActiveCheckbox').attr('checked', 'checked');
    }
    else {
        $('#otauActiveCheckbox').removeAttr('checked');
    }
	
	var zigbeechannel = config.config["zigbeechannel"];
	$("#gwChannel").html(zigbeechannel);
	
		if ((zigbeechannel == 11 ) || (zigbeechannel == 15 ) || (zigbeechannel == 20 ) || (zigbeechannel == 25 )) {
			$("#channelSelect").val(zigbeechannel);
		} else {
			$('#channelSelect')
				.append($("<option></option>")
				.attr("value",zigbeechannel)
				.text(zigbeechannel)); 
			$("#channelSelect").val(zigbeechannel);
		}
		
	var networkOpenDuration = config.config["networkopenduration"];
		$("#networkOpenDuration").val(parseFloat(networkOpenDuration)/60);

		$('.nwOpenText').html('Open the network for '+ parseFloat(networkOpenDuration)/60 + ' ' + ((networkOpenDuration == 60) ? "minute" : "minutes") + ' and allow other ZigBee devices to join the network.');
		
	currentChannel = $('#channelSelect').val();
	
	var panId = config.config["panid"];
	var panid = panId.toString(16);
				if (panid.length >= 4) {
					panid = "0x" + panid;
				} else if (panid.length > 2 && panid.length < 4) {
					panid = "0x0" + panid;
				} else if (panid.length > 1 && panid.length < 3) {
					panid = "0x00" + panid;
				} else if (panid.length > 0 && panid.length < 2) {
					panid = "0x000" + panid;
				} else {
					panid = "0x0000";
				}
	$("#gwNetworkId").html(panid);
}

function displaySetting(config) {

    var swversion = config.config.swversion;

    if (config.config.updatechannel !== 'stable') {
        swversion += ' <span class="label label-info">' + config.config.updatechannel + '</span>';
    }

    $('#gwSwVersion').html(swversion);
	if (Modernizr.sessionstorage) {
		localStorage.setItem("de-gw-swVersion",swversion.substr(0,7));
	}
    $('#gwNameInput').val(config.config.name);
	var d = new Date()
	var n = d.getTimezoneOffset();
	var year = (config.config.utc).substr(0,4);
	var month = (config.config.utc).substr(5, 2);
	var day = (config.config.utc).substr(8, 2);
	var hour = (config.config.utc).substr(11, 2);
	var min = (config.config.utc).substr(14, 2);
	var sec = (config.config.utc).substr(17, 2);
	var dd = new Date(year, month, day, hour, parseInt(min)-n, sec, 0);

	var ddMonth = (dd.getMonth().toString().length == 1) ? "0"+dd.getMonth() : dd.getMonth();
	var ddDay = (dd.getDate().toString().length == 1) ? "0"+dd.getDate() : dd.getDate();
	var ddHours = (dd.getHours().toString().length == 1) ? "0"+dd.getHours() : dd.getHours();
	var ddMinutes = (dd.getMinutes().toString().length == 1) ? "0"+dd.getMinutes() : dd.getMinutes();
	var ddSeconds = (dd.getSeconds().toString().length == 1) ? "0"+dd.getSeconds() : dd.getSeconds();

	var timeFormat = config.config["timeformat"];
		
	$("#timeFormat").val(timeFormat);
			
	$('.gwYearInput').val(dd.getFullYear());
	$('.gwMonthInput').val(ddMonth);
	$('.gwDayInput').val(ddDay);
	
	if (config.config.timeformat == "24h") {
		$('.gwHoursInput').val(ddHours);
		$('.ampm').addClass("hidden");
	} else {
		$('.gwHoursInput').val(convert24to12(ddHours));
		$('.ampm').removeClass("hidden");
		$('.ampm').val(ampm);
	}
	$('.gwMinutesInput').val(ddMinutes);
	$('.gwSecondsInput').val(ddSeconds);
	
	$('#gwGroupDelayInput').val(config.config.groupdelay);
		
    var discovery = config.config.discovery;

    if (discovery === true) {
        $('#internetServiceCheckbox').attr('checked', 'checked');
    }
    else {
        $('#internetServiceCheckbox').removeAttr('checked');
    }

    var curVersion = config.config.swversion;
    var updateVersion = config.config.swupdate.version;
    
    var updateTxt = "";
    if (compareVersionNumbers(curVersion, updateVersion) === -1)
    {
        updateTxt = '<button class="btn" type="bytton" onclick="updateSoftware(); return false;"><b>update to</b> ' + config.config.swupdate.version + ' </button>';
    }
    else if (config.config.fwneedupdate) {
        updateTxt = '<button class="btn" type="bytton" onclick="updateFirmware(); return false;"><b>update firmware</b></button>';
    }
    
    $('#gwSwUpdate').html(updateTxt);
	
	currentYear = $('.gwYearInput').val();
	currentMonth = $('.gwMonthInput').val();
	currentDay = $('.gwDayInput').val();
	currentHour = $('.gwHoursInput').val();
	currentMinute = $('.gwMinutesInput').val();
	currentSecond = $('.gwSecondsInput').val();
	
}
	
/**
 * Poll the gateway for connectivity to inform the user
 * when the update is done.
 */
function pollUpdateReady() {
    $.ajax({
        url: 'api/' + apikey + '/config',
        type: 'GET',
        cache: false,
        headers: { 'Accept': apiversion },
        success: function(json, textStatus, jqXHR) {
            showAlert('alert-success', '<b>OK!</b> Software update done.');
            updateTimerId = undefined;
            //getFullConfiguration();
			window.location.reload();
        },
        error: function(jqXHR, textStatus, errorThrown) {
            switch (jqXHR.status) {
            case 403:
                window.location.assign("/login.html");
                break;

            default:
                updateDots += ' .';
                showAlert('alert-info', '<b>Updating!</b> Please wait and don\'t close this page the update may take up several minutes.' + updateDots, '#system-alerts');
                updateTimerId = setTimeout(pollUpdateReady, 5000);
                break;
            }
        }
    });
}

/**
 * Send request to update the software via the selected update channel.
 */
function updateSoftware() {
    if (updateTimerId) {
        clearTimeout(updateTimerId);
        updateTimerId = undefined;
    }

    updateDots = "";

    $.ajax({
        url: 'api/' + apikey + '/config/update',
        type: 'POST',
        cache: false,
        headers: { 'Accept': apiversion },
        success: function(json) {
            showAlert('alert-info', '<b>Updating!</b> Please wait and don\'t close this page the update may take up several minutes.', '#system-alerts');
            updateTimerId = setTimeout(pollUpdateReady, 8000);
        },
        error: function(jqXHR, textStatus, errorThrown) {
            showAlert('alert-error', '<b>Error!</b> Software update failed, please try again later.', '#system-alerts');
        }
    });
}

/**
 * Send request to update the firmware.
 */
function updateFirmware() {
    if (updateTimerId) {
        clearTimeout(updateTimerId);
        updateTimerId = undefined;
    }

    updateDots = "";

    $.ajax({
        url: 'api/' + apikey + '/config/updatefirmware',
        type: 'POST',
        cache: false,
        headers: { 'Accept': apiversion },
        success: function(json) {
            showAlert('alert-info', '<b>Updating!</b> Please wait and don\'t close this page the update may take up several minutes.', '#network-alerts');
            updateTimerId = setTimeout(pollUpdateReady, 8000);
        },
        error: function(jqXHR, textStatus, errorThrown) {
            showAlert('alert-error', '<b>Error!</b> Firmware update failed, please try again later.', '#network-alerts');
        }
    });
}

function getFullConfiguration() {

    $.ajax({
        url: 'api/' + apikey,
        dataType: 'json',
        type: 'GET',
        cache: false,
        contentType: 'application/json; charset=utf-8',
        headers: { 'Accept': apiversion },
        success: function(json, status, xhr) {
            clearAlert();
            displaySetting(json);
			displayNetworkSetting(json);
			
			config = json;
            config.etag = xhr.getResponseHeader("ETag");
			
			if (config.config.system != "linux-gw") {
				// hide time settings on windows
				$('.gateway-date').html("");
				$('.gateway-time').html("");
				$('.gateway-timezone').html("");
			} else {
				//fill timezoneselect with timezones
				$('.timezoneselect').timezones();
				currentTimezone = config.config.timezone;
			}
		
            // make available for caching
            if (Modernizr.sessionstorage) {
                sessionStorage.config = xhr.responseText;
            }

            setTimeout(checkUpdatedData, POLL_DELAY);
        },
        error: function(jqXHR, textStatus, errorThrown) {
            switch (jqXHR.status) {
            case 403:
                window.location.assign("/login.html");
                break;

            default:
                setTimeout(getFullConfiguration, 1000);
                break;
            }
        },
        timeout: 3000
    });

}

function unlockGateway(seconds) {

    var params = { "unlock" : seconds };

    clearAlert();

    $.ajax({
        url: 'api/' + apikey + '/config',
        dataType: 'json',
        type: 'PUT',
        cache: false,
        contentType: 'application/json; charset=utf-8',
        headers: { 'Accept': apiversion },
        data: JSON.stringify(params),
        success: function(json) {
            showAlert('alert-success', '<b>OK!</b> Unlocked gateway for ' + seconds + ' seconds.', '#system-alerts');
			setTimeout(clearAlert,60000);
        },
        error: function(jqXHR, textStatus, errorThrown) {
            showAlert('alert-error', '<b>Error!</b> Unlock gateway failed!', '#system-alerts');
        }
    });
}

function showChangePasswordAlert(alert, text) {
    var txt = "";

    txt += '<div class="alert ' + alert + '">';
    txt += text;
    txt += '</div>';

    $('#changePasswordAlert').html(txt);
}

$('#changePasswordModal').on('show', function () {
    // clear alert
    $('#oldPasswordInput').val(""); 
    $('#newPasswordInput').val(""); 
    $('#confirmPasswordInput').val(""); 
    $('#changePasswordAlert').html(""); 
})

// check if user did specify a name
function sendChangePassword() {
    clearAlert();
    var oldpw = $('#oldPasswordInput').val();
    var newpw = $('#newPasswordInput').val();
    var confpw = $('#confirmPasswordInput').val();

    if (oldpw.length === 0) {
        showChangePasswordAlert('alert-error', 'Old password not specified!')
    }
    else if (newpw.length < 5) {
        showChangePasswordAlert('alert-error', 'New password must have at least 5 characters!')
    }
    else if (newpw.length === 0) {
        showChangePasswordAlert('alert-error', 'New password not specified!')
    }
    else if (newpw !== confpw) {
        showChangePasswordAlert('alert-error', 'New and confirm password differ!')
    }
    else {
        $('#changePasswordModal').modal('hide');

        var username = "delight"; // fixed
        // combine and base64 encode username:password as in HTTP basic authentification
        var oldhash = Base64.encode(username + ':' + oldpw);
        var newhash = Base64.encode(username + ':' + newpw);

        var params = {
            "username": username,
            "oldhash": oldhash,
            "newhash": newhash
        };

        $.ajax({
            url: 'api/' + apikey + '/config/password',
            dataType: 'json',
            type: 'PUT',
            contentType: 'application/json; charset=utf-8',
            headers: { 'Accept': apiversion },
            //processData: false,
            data: JSON.stringify(params),
            success: function(json) {
                showAlert('alert-success', '<b>OK!</b> Changed password.');
            },
            error: function(jqXHR, textStatus, errorThrown) {
                if (jqXHR.status === 401) {
                    showAlert('alert-error', '<b>Error!</b> Changing password failed, old password wrong!');
                }
                else {
                   showAlert('alert-error', '<b>Error!</b> Changing password failed!');
                }
            }
        });
    }
}

/**
 * Displays or hides the network is open warning.
 */
function checkUpdatedData() {
    if (hidden !== 'undefined') {
        if (document[hidden] === true) {
            console.log('don\'t update while browser window is hidden');
            setTimeout(checkUpdatedData, POLL_DELAY);
            return;
        }
    }
	
    $.ajax({
        url: 'api/' + apikey,
        dataType: 'json',
        type: 'GET',
        cache: false,
        contentType: 'application/json; charset=utf-8',
        headers: {
            'If-None-Match': config.etag,
            'Accept': apiversion
        },
        success: function(json, status, xhr) {
            if (xhr.status === 304) {
                // call self
                setTimeout(checkUpdatedData, POLL_DELAY);
                return;
            }

            // always copy permit join
            config.config.permitjoin = json.config.permitjoin;
            config = json;
					
			// make available for caching
			if (Modernizr.sessionstorage) {
				sessionStorage.config = xhr.responseText;
			}

            checkNetworkOpenWarning();

            config.etag = xhr.getResponseHeader("ETag");
            if (!config.etag) {
                config.etag = "";
            }

            // call self
            setTimeout(checkUpdatedData, POLL_DELAY);
        },
        error: function(jqXHR, textStatus, errorThrown) {
            if (jqXHR.status == 0 || textStatus == "timeout") {
                // try from beginning on (also to clear the alert box on success)
                setTimeout(getFullConfiguration, 1000);
                return;
            }

            switch (jqXHR.status) {
            case 403:
                window.location.assign("/login.html");
                break;

            default:
                setTimeout(checkUpdatedData, POLL_DELAY);
                break;
            }
        },
        timeout: 10000
    });
}

function checkNetworkOpenWarning() {
	if ($.trim($('#network-open-alert').html()).length) {
        // case 1 remove warning
        if (config.config.permitjoin === 0) {
			$('#no-lights-info').removeClass('hidden');
            $('#network-open-alert').html("");
            return;
        }

        // case 2 warning already visible, update
		if (config.config.permitjoin > 0) {
			var txt = '<div class="alert alert-info">';
			txt += '<button type="button" class="close" data-dismiss="alert">&times;</button>';
			txt += '<strong>Info!</strong> Network open. Check the <a href="index.html">main page</a> if new Lights where found. '+ config.config.permitjoin +' seconds left';
			txt += '</div>';
			$('#network-open-alert').html(txt);
			return;
		}
    }

    // case 3 display warning
    if (config.config.permitjoin > 0) {
	    $('#no-lights-info').addClass('hidden');
        var txt = '<div class="alert alert-info">';
        txt += '<button type="button" class="close" data-dismiss="alert">&times;</button>';
        txt += '<strong>Info!</strong> Network open. Check the <a href="index.html">main page</a> if new Lights where found. '+ config.config.permitjoin +' seconds left';
        txt += '</div>';
        $('#network-open-alert').html(txt);
    }
}

function checkTime(i) {
    if (i<10) {i = "0" + i};  // add zero in front of numbers < 10
    return i;
}

/**
* convert 24h schedule.time to 12h format
*/
function convert24to12(hour) {
	var curHour12;
	
	if (hour == "12") {
		curHour12 = "12";
		ampm = "pm";
	} else if (hour == "00") {
		curHour12 = "12";
		ampm = "am";
	} else if ((parseInt(hour) > 12) && (parseInt(hour) < 24)) {
		curHour12 = parseInt(hour) - 12;
		if ((curHour12 > 0) && (curHour12 < 10)) {
			curHour12 = "0" + curHour12;
		}
		ampm = "pm";	
	} else if ((parseInt(hour) > 0) && (parseInt(hour) < 12)) {
		curHour12 = hour;
		ampm = "am";	
	}
	return curHour12;
}

/**
* convert 12h to 24h format
*/
function convert12to24(h) {
	var curHour24;

	if ((h == "12") && (ampm == "pm")) {
		curHour24 = "12";
	} else if ((h == "12") && (ampm == "am")) {
		curHour24 = "00";
	} else if ((parseInt(h) > 0) && (parseInt(h) < 12) && (ampm == "am")) {
		curHour24 = h;	
	} else if ((parseInt(h) > 0) && (parseInt(h) < 12) && (ampm == "pm")) {		
		curHour24 = parseInt(h) + 12;					
	}
	return curHour24;
}

function checkCorrectTime() {
    var maxHour = ($('#timeFormat').val() == "24h") ? 23 : 12;
    var minHour = ($('#timeFormat').val() == "24h") ? 0 : 1;
	var result = true;
	
    if ((parseInt($('.gwHoursInput').val()) < minHour) || (parseInt($('.gwHoursInput').val()) > maxHour)) {
		showAlert('alert-error', '<b>Error!</b> Hour must be between ' + minHour + ' and ' + maxHour);
		result = false;
    }
	if ((parseInt($('.gwMinutesInput').val()) < 0) || (parseInt($('.gwMinutesInput').val()) > 59)) {
		showAlert('alert-error', '<b>Error!</b> Minutes must be between 0 and 59');
		result = false;
    }
	if ((parseInt($('.gwSecondsInputInput').val()) < 0) || (parseInt($('.gwSecondsInputInput').val()) > 59)) {
		showAlert('alert-error', '<b>Error!</b> Seconds must be between 0 and 59');
		result = false;
    }
	return result;
}
